/**
 * 
 */
package milab.lab02.ontology;

import java.util.ArrayList;
import java.util.List;

/**
 * 
 *
 */
public class OntologyConcept {
	public static final int REL_BROADER = 1;
	public static final int REL_NARROWER = 2;
	
	String name;
	List<OntologyConcept> broader;
	List<OntologyConcept> narrower;
	
	/**
	 * @param name
	 */
	public OntologyConcept(String name) {
		super();
		this.name = name;
	}

	public boolean equals(String n) {
		if (this.name.equalsIgnoreCase(n)) return true;
		return false;
	}
	/**
	 * add a concept to the given related concept list
	 * @param c concept to add
	 * @param relationType relation relationType 
	 */
	public void addRelation(OntologyConcept c, int relationType) {
		switch(relationType) {
		case REL_BROADER:
			if (this.broader.contains(c)) break;
			this.broader.add(c);
			c.addRelation(this, REL_NARROWER);
			break;
		case REL_NARROWER:
			if (this.narrower.contains(c)) break;
			this.narrower.add(c);
			c.addRelation(this, REL_BROADER);
			break;
		default:
			// TODO error handling
		}
	}
	
	/**
	 * get related concepts
	 * @param relationType relationType of the relation
	 */
	public List<OntologyConcept> getRelatedConcepts(int relationType) {
		switch(relationType) {
		case REL_BROADER:
			return this.broader;
		case REL_NARROWER:
			return this.narrower;
		default:
			// TODO error handling
			return null;
		}
	}
	
	public boolean isRelated(OntologyConcept c, int relationType) {
		switch(relationType) {
		case REL_BROADER:
			return this.broader.contains(c);
		case REL_NARROWER:
			return this.narrower.contains(c);
		default:
			// TODO error handling
		}
		return false;
	}
	
	public boolean isRelated(OntologyConcept c) {
		if (this.broader.contains(c)) return true;
		if (this.narrower.contains(c)) return true;
		return false;
	}
	
	/**
	 * get related concepts as string array
	 * @param relationType relationType of the relation
	 *
	public List<String> getRelatedConceptsAsStrings(int relationType) {
		String[] strs = new String[1];
		List<String> ret = new ArrayList<String>();
		switch(relationType) {
		case REL_BROADER:
			
		case REL_NARROWER:
			
		default:
			// TODO error handling
			return null;
		}
	}
	*/
}
